petsc-3.7.7 2017-09-25
Report Typos and Errors

# MatZeroRowsIS

Zeros all entries (except possibly the main diagonal) of a set of rows of a matrix.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode MatZeroRowsIS(Mat mat,IS is,PetscScalar diag,Vec x,Vec b)

Collective on Mat

### Input Parameters

| mat | - the matrix
| is | - index set of rows to remove
| diag | - value put in all diagonals of eliminated rows
| x | - optional vector of solutions for zeroed rows (other entries in vector are not used)
| b | - optional vector of right hand side, that will be adjusted by provided solution

### Notes

For the AIJ and BAIJ matrix formats this removes the old nonzero structure, but does not release memory. For the dense and block diagonal formats this does not alter the nonzero structure.

If the option MatSetOption(mat,MAT_KEEP_NONZERO_PATTERN,PETSC_TRUE) the nonzero structure of the matrix is not changed (even for AIJ and BAIJ matrices) the values are merely zeroed.

The user can set a value in the diagonal entry (or for the AIJ and row formats can optionally remove the main diagonal entry from the nonzero structure as well, by passing 0.0 as the final argument).

For the parallel case, all processes that share the matrix (i.e., those in the communicator used for matrix creation) MUST call this routine, regardless of whether any rows being zeroed are owned by them.

Each processor can indicate any rows in the entire matrix to be zeroed (i.e. each process does NOT have to list only rows local to itself).

You can call MatSetOption(mat,MAT_NO_OFF_PROC_ZERO_ROWS,PETSC_TRUE) if each process indicates only rows it owns that are to be zeroed. This saves a global synchronization in the implementation.

### See Also

MatZeroRows(), MatZeroRowsStencil(), MatZeroEntries(), MatZeroRowsLocal(), MatSetOption()

Level:intermediate
Location:src/mat/interface/matrix.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages